include get.e
include file.e
include sort.e
include crypto10.e

constant
        TRUE            =  1,
        ERROR_FAIL      = -1,
        PFILEDIR        = "users\\",
        MasterPassFname = ".\\master.pwf",
        SysopListFname  = ".\\sysops.enc"

object oldpass, newpass, cmdline, allusers,
       oldrec, newrec, ok, name, fName

--------------------------------------------------------------
function IsSame(object a, object b)
   return compare(a,b) = 0
end function

function KillLastChar(object data)
   if atom(data)      then return {} end if
   if length(data)<=1 then return {} end if
   return data[1..length(data)-1]
end function

function DeleteRecord(integer which, object data)
integer len
   if atom(data) then return {} end if
   len = length(data)
   if len = 1 then return {} end if
   return data[1..which-1] & data[which+1..len]
end function

function GetDir_FNames(sequence path, sequence spec)
object junk
   if length(spec) then
        junk = dir(path &  spec)
   else junk = dir(path & "*.*")
   end if
   if atom(junk) then return {} end if
   if length(junk) then
      for i = 1 to length(junk) do
          junk[i] = junk[i][D_NAME]
      end for
      return junk
   end if
   return {}
end function

function GetDir_UserFNames()
object users, path, onedir     users={} path={}
   for subdir = 'a' to 'z' do
      path  = PFILEDIR & subdir & '\\'
      onedir= GetDir_FNames(path,"*.pfl")
      if length(onedir) then
         onedir = sort(onedir)
         for i = 1 to length(onedir) do
            users = append(users, onedir[i])
         end for
      end if
   end for
   return users
end function

function LoadSeqFile(sequence filename)
--loads a sequence to a file...
integer fn
object data
   fn = open(filename,"r")
   if fn = -1 then return ERROR_FAIL end if
   data = get(fn)
   if data[1] = GET_SUCCESS then
        data = data[2]
   else data = ERROR_FAIL
   end if
   close(fn)
   return data
end function

function SaveSeqFile(sequence filename, sequence data)
--saves a sequence to a file...
integer fn
   fn = open(filename,"w")
   if fn = -1 then return ERROR_FAIL end if
   print(fn,data)
   close(fn)
   return TRUE
end function

------------------------------------------------------------------
------------------------------------------------------------------
cmdline = command_line()
if length(cmdline) != 3 then
   puts(1,"Improper usage.\n")
   abort(1)
end if

puts(1,"Zipping/Backing up server...\n")
system("zipsrvr 000",2)
cmdline = cmdline[3]
newpass = cmdline
oldpass = LoadSeqFile(MasterPassFname)

--process all the user files...
allusers = GetDir_UserFNames()
for i = 1 to length(allusers) do
    name = allusers[i]
    name = name[1..length(name)-4]
    name = PFILEDIR & name[1] & '\\' & name
    fName= name & ".pfl"
    puts(1,"Processing:" & name & '\n')

    oldrec = LoadSeqFile(fName)
    if atom(oldrec) then
         puts(1,"ERROR LOADING:" & name & '\n')
    else oldrec = DecryptData(oldrec,oldpass)
         newrec = EncryptData(oldrec,newpass)
         ok = SaveSeqFile(fName,newrec)
         if ok then
              puts(1,"NewUserFile Saved:" & name & '\n')
         else puts(1,"ERROR SAVING:" & name & '\n')
         end if
    end if
end for

--process sysop list and master password files themselves
fName = SysopListFname
puts(1,"Processing:" & fName & '\n')
oldrec = LoadSeqFile(fName)
if atom(oldrec) then
     puts(1,"ERROR LOADING:" & fName & '\n')
else oldrec = DecryptData(oldrec,oldpass)
     newrec = EncryptData(oldrec,newpass)
     ok = SaveSeqFile(fName,newrec)
     if ok then
          puts(1,"File Saved:"   & fName & '\n')
     else puts(1,"ERROR SAVING:" & fName & '\n')
     end if
end if

fName = MasterPassFname
puts(1,"Processing:" & fName & '\n')
ok = SaveSeqFile(fName,newpass)
if ok then
     puts(1,"File Saved:"   & fName & '\n')
else puts(1,"ERROR SAVING:" & fName & '\n')
end if


